# -*- coding: utf-8 -*-
"""
Created on Fri Nov  8 14:29:03 2024

@author: mstep
"""

def generate_permutations(values, is_used, current_permutation):
    if len(current_permutation) == len(values):
        yield current_permutation
    else:
        for i in range(len(values)):
            if not is_used[i]:
                current_permutation.append(values[i])
                is_used[i] = True

                # Recursively expand out the current permutation.
                # The recursive call is itself a generator so
                # loop through its results and yield them.
                for permutation in generate_permutations(
                    values, is_used, current_permutation):
                        yield permutation

                current_permutation.pop()
                is_used[i] = False

# Main program
values = ['A', 'B', 'C']
is_used = [False for _ in values]
current_permutation = []

for permutation in generate_permutations(values, is_used, current_permutation):
    print(permutation)
